
library ieee; use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity mod_239_multiplier is
port(
  x, y: in std_logic_vector(7 downto 0);
  z: out std_logic_vector(7 downto 0)
);
end mod_239_multiplier;

architecture circuit of mod_239_multiplier is
  component mod_239_reducer is
  port (
    x: in std_logic_vector(15 downto 0);
    z: out std_logic_vector(7 downto 0)
  );
  end component;
  signal product: std_logic_vector(15 downto 0);

begin
  product <= x*y;
  reducer_component: mod_239_reducer port map(product, z);
end circuit;

