----------------------------------------------------------------
-- Montgomery Exponentiation (Montgomery_exponentiation_lsb.adb)
--  
-- X ** Y mod M using K bits numbers (LSB first)
-- Using Montgomery multiplication
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with finite_fields; use finite_fields;
procedure Montgomery_exponentiation_lsb is 
x, y, q, e, ty, z: integer;
binary_x: bit_vector(0 .. k-1);
begin
loop
Put("x = "); Get(x); New_Line;
Put("y = "); Get(y); New_Line;
q := x;
for i in 0 .. k-1 loop binary_x(i) := q mod 2; q := q/2; end loop; 
----------------------------------------------
e := exp_k;
ty := mp(y, exp_2k);
--Put("ty = "); Put(ty); New_Line;

for i in 0 .. k-1 loop
 if binary_x(i) = 1 then e := mp(e, ty); end if;
 ty := mp(ty, ty);
--Put("e = "); Put(e); New_Line;
end loop;
z := mp(e, 1);
----------------------------------------------
Put(y); Put(" ** "); Put(x); Put(" mod "); Put(m); Put(" = "); Put(z); New_Line; New_Line;
end loop;
end Montgomery_exponentiation_lsb;