----------------------------------------------------------------
-- Binary mod M addition (binary_mod_M_addition.adb)
-- 
-- Adds X and Y mod M using K bits numbers
-- Preconditions X < M, X < 2**K, Y < M, Y < 2**K and M < 2**K
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
--with finite_fields; use finite_fields;
procedure binary_mod_m_addition is 
   x, y, z1, z2, c1, c2, m, k, z: integer;
begin
   loop
      Put("x = "); Get(x); New_Line;
      Put("y = "); Get(y); New_Line;
      Put("m = "); Get(m); New_Line;
      Put("k = "); Get(k); New_Line;
      ----------------------------------------------
      z1 := x + y; z2 := (z1 mod 2**k) + (2**k - m);
      c1 := z1/2**k; c2 := z2/2**k; 
      if c1 = 0 and c2 = 0 then 
         z := (z1 mod 2**k); 
      else 
         z := (z2 mod 2**k); 
      end if;
      ----------------------------------------------
      Put(x); Put(" + "); Put(y); Put(" mod "); Put(m); 
      Put(" = "); Put(z); New_Line; New_Line;
   end loop;
end binary_mod_m_addition;