----------------------------------------------------------------
-- mod M Exponentiation (mod_m_exponentiation.adb)
-- 
-- X ** Y mod M using K bits numbers (LSB first)
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with finite_fields; use finite_fields;
procedure mod_m_exponentiation_lsb is 
x, y, m, k, e, z, q: integer;
binary_x: bit_vector(0 .. k-1);
begin
loop
Put("m = "); Get(m); New_Line;
Put("k = "); Get(k); New_Line;
Put("x = "); Get(x); New_Line;
Put("y = "); Get(y); New_Line;
q := x;
for i in 0 .. k-1 loop binary_x(i) := q mod 2; q := q/2; end loop; 
----------------------------------------------
e := 1;
for i in 0 .. k-1 loop
 if binary_x(i) = 1 then e := (e*y) mod m; end if;
 y := (y*y) mod m ;
end loop;
z := e;
----------------------------------------------
Put(y); Put(" ** "); Put(x); Put(" mod "); Put(m); Put(" = "); Put(z); New_Line; New_Line;
end loop;
end mod_m_exponentiation_lsb;